Page MenuHomePhabricator

Create a change tag for edits made using DiscussionTools
Closed, ResolvedPublic

Description

To better understand how people are using #discussion-tools [1], we would like to create a new change tag so people can easily filter Recent Changes feeds for edits made using DiscussionTools features.

Uses cases

  • Review the content of edits posted using the Replying and Starting new discussion workflows so we can detect bugs and developed a better understanding for how contributors are using the feature(s)
  • Calculate aggregate DiscussionTools usage metrics
  • Enable communities to understand how DiscussionTools are being used on their wiki

Considerations

Open questions

  • How – if at all – should the text input mode (e.g. source vs. rich text) be tracked? Being discussed
  • Should there be one change tag for all edits made using DiscussionTools?
  • Should each DiscussionTools feature (e.g. Replying) have its own tag? Yes
  • What should the change tag(s) be called? Being discussed.
  • What maintenance burden do we inherit by introducing additional tags? Minimal maintenance.

Done

On any wiki where DiscussionTools are deployed, people are able to use Special:RecentChanges to identify:

  • Edits made using DiscussionTools: hidden tag (only visible on Special:Tags)
  • Edits made using a specific DiscussionTool feature (e.g. T233446 or T233443): Reply or New section
  • Edits made using DiscussionTools and the input method they used to publish those edits (e.g. source vs. visual): Source or Visual [2]

  1. e.g. What kinds of edits are contributors making?
  2. Visual has not been implemented yet

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
JTannerWMF added a subscriber: JTannerWMF.

This task needs more information. What to consider for edits made when using workflow?

I'm working on a patch for this which will apply placeholder tags for likely edit types. The bulk of the actual technical work is adjusting the VisualEditorEdit API to allow the tags to be customized, anyway.

ppelberg updated the task description. (Show Details)Jan 24 2020, 2:26 AM
ppelberg updated the task description. (Show Details)Jan 24 2020, 2:33 AM

How – if at all – should the text input mode (e.g. source vs. rich text) be tracked?

So, my patch-in-progress handles this sort of thing so far by having a top-level discussiontools tag, and then secondary tags for what was done. Thus you wind up with an edit tagged as discussiontools+discussiontools-reply. Adding in further tagging for the mode would be viable -- discussiontools-visual or similar.

How – if at all – should the text input mode (e.g. source vs. rich text) be tracked?

So, my patch-in-progress handles this sort of thing so far by having a top-level discussiontools tag, and then secondary tags for what was done. Thus you wind up with an edit tagged as discussiontools+discussiontools-reply. Adding in further tagging for the mode would be viable -- discussiontools-visual or similar.

Great to hear the approach you've been taken will enable us to tag the input method used.

This means an edit a contributor makes using the DiscussionTools Reply feature in rich text editing mode would be assigned three tags: discussiontools + discussiontools-reply+ discussiontools-visual [1]. Please tell me if this would not be the case.

Which leads me to wonder: @DLynch, are you aware of an added maintenance burden that comes with introducing new edit tags that could motivate us to use fewer of them when possible?


  1. I realize the names of the tags themselves could change.

Change 567122 had a related patch set uploaded (by DLynch; owner: DLynch):
[mediawiki/extensions/VisualEditor@master] Suppress VE change tags if user-provided tags are given

https://gerrit.wikimedia.org/r/567122

Change 567123 had a related patch set uploaded (by DLynch; owner: DLynch):
[mediawiki/extensions/DiscussionTools@master] Tag DiscussionTools edits

https://gerrit.wikimedia.org/r/567123

Change 567122 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@master] Tag VE edits from the client-side

https://gerrit.wikimedia.org/r/567122

Change 567123 merged by jenkins-bot:
[mediawiki/extensions/DiscussionTools@master] Tag DiscussionTools edits

https://gerrit.wikimedia.org/r/567123

ppelberg updated the task description. (Show Details)Feb 5 2020, 12:23 AM
ppelberg updated the task description. (Show Details)

Which leads me to wonder: @DLynch, are you aware of an added maintenance burden that comes with introducing new edit tags that could motivate us to use fewer of them when possible?

Outcome from today's planning meeting: additional tags do not incur a significant amount of maintenance burden. We can also deprecate tags as needed.


RE how the tags are implemented, one adjustment and one question...

Adjustment

  • @DLynch can we please make it so all edits made using DiscussionTools are explicitly labeled with the "input mode" used to make the edit?
    • E.g. A reply posted using visual made would receive the discussiontools-visual tag and a reply posted using the source mode would receive the discussiontools-source tag.

Question

  • Why is it that a reply made using DiscussionTools in visual mode would receive three tags instead of two?
    • I would assume discussiontools-reply discussiontools-visual would be sufficient.

The "adjustment" and "question" above are outcomes of a discussion with @Whatamidoing-WMF this afternoon.


  1. https://gerrit.wikimedia.org/r/#/c/mediawiki/extensions/DiscussionTools/+/567123/
ppelberg updated the task description. (Show Details)Feb 5 2020, 12:36 AM
ppelberg updated the task description. (Show Details)

Moving to Needs more work since it needs input from @DLynch

DLynch added a comment.Feb 5 2020, 6:10 PM

Why is it that a reply made using DiscussionTools in visual mode would receive three tags instead of two?

My initial logic was just that it'd be simpler for search, rather than anyone interested in the data having to know up front what all the possible modes were. That said, I can certainly remove the pure discussiontools tag, and you can remember when searching what the options are.

Why is it that a reply made using DiscussionTools in visual mode would receive three tags instead of two?

My initial logic was just that it'd be simpler for search, rather than anyone interested in the data having to know up front what all the possible modes were. That said, I can certainly remove the pure discussiontools tag, and you can remember when searching what the options are.

That thinking makes sense – thank you for explaining that, David. Let's keep the generic discussiontools tag for now.

In sum, the tags should be as follows:

  1. An overarching discussiontools tag for all edits made using DiscussionTools
  2. When applicable, an edit tag for the specific discussiontool feature used to make said edit (e.g. discussiontools-reply, discussiontools-newsection, and discussiontools-edit)
  3. When applicable, an edit tag for the input mode used to make an edit (discussiontools-visual or discussiontools-source)

Change 570389 had a related patch set uploaded (by DLynch; owner: DLynch):
[mediawiki/extensions/DiscussionTools@master] Add editor-mode changetags

https://gerrit.wikimedia.org/r/570389

Demian added a comment.Feb 5 2020, 6:57 PM

My 2 cents: keep the visible tags short (in the history), without redundancy. Examples: "Tags: DiscussionTools, reply", "Tags: DiscussionTools, new section", "Tags: DiscussionTools, edit", "Tags: DiscussionTools, reply, source", "Tags: DiscussionTools, reply, visual", etc.
Maybe even hide the "DiscussionTools" tag (use only for searching) and show only "reply, source" or "new section, visual".

The concern: I've seen once (can't find it now...) in the history of one of the prototypes something like:
`(cur prev) 19:15, 4 February 2020‎ Testuser (talk contribs)‎ 1,817 bytes +238‎ (→‎How can we make this article better?: Reply) (undo) (Tags: discussiontools, discussiontools-reply, discussiontools-source)

The tags were almost half of that one entry, which occupied two lines but carried little useful information, repeating the very long "discussiontools" word 3 times. That would make using the history very uncomfortable.

I haven't been following the progress of this feature. It might be so that the visible tags are already short at the current state, in which case disregard this comment.

In T242184#5853349, @AronManning wrote:

The tags were almost half of that one entry, which occupied two lines but carried little useful information, repeating the very long "discussiontools" word 3 times. That would make using the history very uncomfortable.

The tradeoff between the amount of space an edit tag takes up in page histories, Special:Watchlists and Special:RecentChanges and the usefulness of the tag itself is important to consider. Thank you for raising this.

@Whatamidoing-WMF, @DLynch and I are thinking through how to move forward.

I'll note that site admins will be able to change how the tags look (and whether they appear at all) by editing the localisation messages for them, same as for the currently existing tags, e.g. https://en.wikipedia.org/wiki/MediaWiki:Tag-visualeditor-wikitext. But we want to add the tags to enable filtering by them on RecentChanges etc.

JTannerWMF updated the task description. (Show Details)Feb 6 2020, 8:04 PM

Change 570389 merged by jenkins-bot:
[mediawiki/extensions/DiscussionTools@master] Add editor-mode changetags

https://gerrit.wikimedia.org/r/570389

JTannerWMF added a project: Editing QA.

T244531 We moved the open questions that are not a blocker here. This ticket is ready for QA and close out.

JTannerWMF moved this task from Inbox to High Priority on the Editing QA board.Feb 6 2020, 8:12 PM

Change 570718 had a related patch set uploaded (by DLynch; owner: DLynch):
[mediawiki/extensions/DiscussionTools@master] Change tags method so anon edits will get tagged

https://gerrit.wikimedia.org/r/570718

Change 570723 had a related patch set uploaded (by DLynch; owner: DLynch):
[mediawiki/extensions/VisualEditor@master] Change tags method so anon edits will get tagged

https://gerrit.wikimedia.org/r/570723

Change 570724 had a related patch set uploaded (by Bartosz Dziewoński; owner: Bartosz Dziewoński):
[mediawiki/extensions/VisualEditor@master] Revert "Tag VE edits from the client-side"

https://gerrit.wikimedia.org/r/570724

Change 570724 abandoned by Bartosz Dziewoński:
Revert "Tag VE edits from the client-side"

Reason:
Let's go with https://gerrit.wikimedia.org/r/c/mediawiki/extensions/VisualEditor/ /570723 instead

https://gerrit.wikimedia.org/r/570724

Change 570727 had a related patch set uploaded (by DLynch; owner: DLynch):
[mediawiki/extensions/VisualEditor@wmf/1.35.0-wmf.18] Change tags method so anon edits will go through

https://gerrit.wikimedia.org/r/570727

Change 570723 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@master] Change tags method so anon edits will go through

https://gerrit.wikimedia.org/r/570723

Change 570727 merged by jenkins-bot:
[mediawiki/extensions/VisualEditor@wmf/1.35.0-wmf.18] Change tags method so anon edits will go through

https://gerrit.wikimedia.org/r/570727

Mentioned in SAL (#wikimedia-operations) [2020-02-06T22:50:37Z] <jforrester@deploy1001> Synchronized php-1.35.0-wmf.18/extensions/VisualEditor: T242184 Change tags method so anon edits will go through (duration: 01m 08s)

Change 570718 merged by jenkins-bot:
[mediawiki/extensions/DiscussionTools@master] Change tags method so anon edits will get tagged

https://gerrit.wikimedia.org/r/570718

It turns out anonymous users can't apply change tags, so the client-side approach broke editing/replying for them. The second set of patches fixes that.

Ryasmeen edited projects, added Verified; removed Editing QA.Feb 10 2020, 8:09 PM

@DLynch, the tag we are currently using to identify edits made using the "Replying" DiscussionTools feature read replied [1] – are you able to change the tag such that edits made using the DiscussionTools replying feature read Reply?


Current edit tag

I did some research into hiding tags: it hides the tag entirely if the associated message is present-but-disabled. (If there's no message at all, it just shows whatever the tag name is.) Messages are disabled by setting them to literally the empty-string or to -.

This can be done either by default, by setting the bundled translation in the extension to - (and by including {{ignored}} in the translation-description as a convention, it seems), or by per-wiki setting the contents of the special page for the translation (in this case MediaWiki:Tag-discussiontools).

The open question for @ppelberg would be: should this be hidden by default?

ppelberg updated the task description. (Show Details)Feb 12 2020, 12:15 AM
ppelberg added a comment.EditedFeb 12 2020, 9:56 PM

The open question for @ppelberg would be: should this be hidden by default?

Thank you for investigating, David. Two things below: notes from chat and next steps.

Notes from chat

  • Our current understanding is that hiding the generic DiscussionTools edit tag by default means that edit tag would not appear in any page history history, BUT anyone who knows the generic tag exists would still be able to filter RecentChanges using it. Said another way: disabling the messages just suppresses the display.

Next steps

  • 1. RE T242184#5873066 [1], yes, can we please hide the generic DiscussionTools tag by default? Although, implementing this is not a blocker for release. As such, let's track that work in this ticket: T245069
  • 2. The tag we are currently using to identify edits made using the "Replying" DiscussionTools feature read replied– are you able to change the tag such that edits made using the DiscussionTools replying feature read Reply?

The open question for @ppelberg would be: should this be hidden by default?

The tags would likely be shorter if we had a name for the tool (and for the project). The lack of such a name is becoming increasingly inconvenient.

The tags would likely be shorter if we had a name for the tool (and for the project). The lack of such a name is becoming increasingly inconvenient.

We are following community feedback, translation best practices, and evolved industry best practices by using descriptive names for product features and not creating sub-brands for each new features within already branded products (i.e. MediaWiki). It seems unwise to go against all of those simply for Phabricator tag convenience.

Indeed, projects with a code name like Echo and Flow were forced through a very irritating rename to Notifications and StructuredDiscussions, and so we picked a bland name from the start to avoid that. You're welcome to refer to DiscussionTools as DT if you need a shorter name, I think it's a mostly unambiguous abbreviation.

matmarex triaged this task as High priority.Feb 20 2020, 6:20 PM

Change 574505 had a related patch set uploaded (by Bartosz Dziewoński; owner: DLynch):
[mediawiki/extensions/DiscussionTools@master] Adjust change tag display

https://gerrit.wikimedia.org/r/574505

matmarex added a subscriber: DLynch.

I merged the subtask back into this task, it turned out to be easy to implement and @DLynch already did that, so I think it'll be easier not to track it separately.

Change 574505 merged by jenkins-bot:
[mediawiki/extensions/DiscussionTools@master] Adjust change tag display

https://gerrit.wikimedia.org/r/574505

I merged the subtask back into this task, it turned out to be easy to implement and @DLynch already did that, so I think it'll be easier not to track it separately.

Sounds good.

Also, this looking to be working as we intended it to [1]. Great.


  1. https://en.wikipedia.beta.wmflabs.org/wiki/Special:RecentChanges?hidebots=1&hidecategorization=1&hideWikibase=1&tagfilter=discussiontools&limit=50&days=7&urlversion=2
ppelberg closed this task as Resolved.Feb 24 2020, 9:46 PM
ppelberg updated the task description. (Show Details)